import discord
from discord import app_commands
from discord.ext import commands

class Server(commands.Cog):
    def __init__(self, bot):
        self.bot = bot

    @commands.Cog.listener()
    async def on_ready(self):
        print("Server Online")

    server = app_commands.Group(name="server", description="Manage your server!")

    @server.command(name="members", description="Shows how many members are in the server")
    async def members(self, interaction: discord.Interaction):
        em = discord.Embed(title="Member Count", description=f"Total Members: {interaction.guild.member_count}",
                           color=interaction.user.color)
        await interaction.response.send_message(embed=em)

    @server.command(name="stats", description="Check the servers stats")
    async def stats(self, interaction: discord.Interaction):
        role_count = len(interaction.guild.roles)

        em = discord.Embed(color=interaction.user.color)
        em.add_field(name="Server Name", value=f"{interaction.guild.name}", inline=False)
        em.add_field(name="Member Count", value=f"{interaction.guild.member_count}", inline=False)
        em.add_field(name="Verify Level", value=f"{interaction.guild.verification_level}", inline=False)
        em.add_field(name="Highest Role", value=f"{interaction.guild.roles[-1]}", inline=False)
        em.add_field(name="Number Of Roles", value=f"{role_count}", inline=False)
        em.add_field(name="Guild ID", value=f"{interaction.guild.id}", inline=False)
        await interaction.response.send_message(embed=em)

    @server.command(name="leave", description="Leaves the guild")
    @commands.has_permissions(administrator=True)
    async def leave(self, interaction: discord.Interaction):
        await interaction.response.send_message("Left the guild")
        await interaction.guild.leave()

async def setup(bot):
    await bot.add_cog(Server(bot))